#include <io.h>
#include <timer.h>
#include "my_defs.h"
#include "serial.h"
#include "tools.h"
#include "ir.h"


unsigned int get_rc5( void)
{
	unsigned char ir_delay, dummy, dummy1;
	unsigned int tmp=0;

		//zeit fuer 1/2 bit messen
		timer0_source(CK256);	//update every 32us
		timer0_start();
		loop_until_bit_is_set(PINB, PINB0);
		ir_delay = inp(TCNT0);
		ir_delay++;

		//daten empfangen
		for(dummy=0; dummy < 13; dummy++)
		{
			dummy1 = bit_is_set(PINB, PINB0);				//Flanke aufnehmen
			timer0_start();
			tmp=tmp << 1;
			while(1)
			{
				if(inp(TCNT0) > ir_delay)	return 0;		//Flanke ist nicht eingetroffen!

				if (dummy1)				//flanke gewechselt ?
				{	if(bit_is_clear(PINB, PINB0))
					{
						tmp |=1;
						break;
					}
				}
				else
				{	if(bit_is_set(PINB, PINB0))
					{
						break;
					}
				}
			}
			timer0_start();			//delay
			while(inp(TCNT0) <= ir_delay);
		}
	return tmp;
}
