#include <io.h>
#include <timer.h>
#include "my_defs.h"
#include "serial.h"
#include "tools.h"

unsigned int get_rc5( void)
{
	unsigned char ir_delay, dummy, dummy1;
	unsigned int tmp=0;

		//zeit fuer 1/2 bit messen
		timer0_start();
#if MINIMEGAHMPEG == FALSE	// Hmpeg
		while (REMOTE_CLEAR)
		{	if (inp(TCNT0) > 40) return 0;
		}
//		ir_delay = inp(TCNT0) +3;
		ir_delay = 0x30;
#else	// MiniMegaHmpeg
		while (REMOTE_CLEAR)
		{ 	if (inp(TCNT0) > 30) return 0;
		}
		ir_delay = 0x24;
#endif

		//daten empfangen
		for(dummy=0; dummy < 13; dummy++)
		{
			dummy1 = REMOTE_SET;		//Flanke aufnehmen
			timer0_start();
			tmp=tmp << 1;
			while(1)
			{
				if(inp(TCNT0) > ir_delay)	
				{	
//					sendstring("Fehler:");
//					sendstring(byte_to_hex(ir_delay));
//					sendstring(byte_to_hex(dummy));
//					new_line();
					return 0;			//Flanke ist nicht eingetroffen!
				}

				if (dummy1)				//flanke gewechselt ?
				{	if(REMOTE_CLEAR)
					{
						tmp |=1;
						break;
					}
				}
				else
				{	if(REMOTE_SET)
					{
						break;
					}
				}
			}
			timer0_start();				//delay
			while(inp(TCNT0) <= ir_delay);
		}
//	sendstring("OK! ");
//	print_short(tmp);
//	new_line();
	return tmp;
}
