#ifndef ___SERIAL_H
#define ___SERIAL_H


void sendstring( char * string);
void sendstring_( char * string);
void new_line( void);
void putchar (unsigned char);
void putlong(unsigned long);


#if MINIMEGAHMPEG == FALSE	// Hmpeg
	#define F_CPU            8000000      /* 8Mhz */
	#define UART_BAUD_RATE     38400      
#else	// MiniMegaHmpeg
	#define F_CPU            6000000      /* 6Mhz */
	#define UART_BAUD_RATE     9600      
#endif


#define EEPROM_SIZE (E2END+1)
#define UART_BAUD_SELECT (F_CPU/(UART_BAUD_RATE*16l)-1)

#endif
